﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TheTeachersTimesaverCore.Types;
using System.Diagnostics;
using Infragistics.Windows.Editors;

namespace TimeSpanEditor
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    /// 

    public partial class MainWindow : Window
    {
        public static string AmPm;

        public MainWindow()
        {
            CourseScheduleInfo TestObject = new CourseScheduleInfo();
            this.DataContext = TestObject;
            InitializeComponent();
        }

        private void XamMaskedEditor_EditModeEnding(object sender, Infragistics.Windows.Editors.Events.EditModeEndingEventArgs e)
        {
            MainWindow.AmPm = (sender as XamMaskedEditor).DisplayChars[6].DrawString + (sender as XamMaskedEditor).DisplayChars[7].DrawString;
        }
    }

    public class TimeConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null)
            {
                string[] result = value.ToString().Split(':');
                if (result.Count() == 3)
                {
                    return result[0] + ":" + result[1] + " " + MainWindow.AmPm;
                }
                
            }
            return Binding.DoNothing;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null)
            {
                string[] result = value.ToString().Split(new char[2] { ' ', ':' });
                int h;
                if (Int32.TryParse(result[0], out h) && Int32.TryParse(result[1], out h))
                {
                    if (result[2].ToUpper() == "PM" && Int32.Parse(result[0]) < 12) return new TimeSpan(Int32.Parse(result[0]) + 12, Int32.Parse(result[1]), 0);
                    else if (result[2].ToUpper() == "AM" && Int32.Parse(result[0]) > 12) return new TimeSpan(Int32.Parse(result[0]) - 12, Int32.Parse(result[1]), 0);
                    return new TimeSpan(Int32.Parse(result[0]), Int32.Parse(result[1]), 0);
                }
            }
            return Binding.DoNothing;
        }
    }

}
